package com.almworks.jira.structure.apiclient;

import com.almworks.jira.structure.api.query.StructureQuery;
import com.almworks.jira.structure.api.structure.StructureManager;
import com.atlassian.jira.issue.Issue;
import com.atlassian.jira.workflow.condition.AbstractJiraCondition;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Map;

public abstract class AbstractStructureQueryCondition extends AbstractJiraCondition {
  private static final Logger log = LoggerFactory.getLogger(AbstractStructureQueryCondition.class);

  protected final StructureManager myStructureManager;

  protected AbstractStructureQueryCondition(StructureManager manager) {
    myStructureManager = manager;
  }

  protected boolean matchesIssue(StructureQuery query, Map transientVars, Map args) {
    Issue issue = getIssue(transientVars);
    Long issueId = issue.getId();
    if (issueId == null) return true;
    // todo implement
//    for (Structure s : myStructureManager.getStructuresWithIssue(issueId, PermissionLevel.VIEW)) {
//        if (query.checkIssue(issueId, s.getForest(caller, false), caller, false)) {
//          return true;
//        }
//    }
    return false;
  }
}
